# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  

#!/bin/bash

# JPR 2/5/2011
#if [ $UID = 0 ] 
#then
  # Set all local variables
  scriptDir=`pwd`/scripts
##  cd $scriptsDir
  source scripts/LocalFunctions.sh
##  cd $scriptsDir
  source scripts/CreaTools-configure.sh


  if [ -e $generationdir ]
  then

#--------Active SSH agent to the next operations---------------------------------------------------------
	echo "Active SSH agent to copy files to the Cluster:"
	ssh-add	


#--------CreaTools-Bin  for Package developers---------------------------------------------------------

	echo generationdir:
	echo $generationdir
	cd $generationdir
	mkdir GenerateBinTGZ
    cd GenerateBinTGZ

	ln -s $installPrefix creatools_install
	ln -s $installPrefixThird thirdparty_install

  	source creatools_install/share/creatools/Version.sh 
#	distanceAdress=davila@tux.creatis.insa-lyon.fr:creatools/creaTools/v$creatoolsMajorVersion.$creatoolsMinorVersion.x/
	distanceAdress=davila@tux.creatis.insa-lyon.fr:creatools/creaTools/v$creatoolsMajorVersion.x.x/
	fileTGZ=CreaTools-Bin-Release-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion-`getDistrib`-`getDistribVersion`.tgz
	fileTGZstring=CreaTools-Bin-Release-\$creatoolsMajorVersion.\$creatoolsMinorVersion.\$creatoolsBuildVersion-\`getDistrib\`-\`getDistribVersion\`
	tar -cvzf $fileTGZ creatools_install/* thirdparty_install/*
	scp $fileTGZ $distanceAdress/$fileTGZ 

#--------CreaTools-Final_User---------------------------------------------------------

	creatoolsTPLaux=creatoolsTPLaux
	rm -rf $creatoolsTPLaux
	mkdir $creatoolsTPLaux
	cd $creatoolsTPLaux
	mkdir bin
	mkdir share
	mkdir share/creatools
	echo "export PATH=\$PATH:\$1/bin" > share/creatools/creatools_TPLaux_config.sh
# MacOs
	if [ `getDistrib` == MacOS ]  ; then 
		echo "export DYLD_LIBRARY_PATH=\$LD_LIBRARY_PATH:\$1/lib" >> share/creatools/creatools_TPLaux_config.sh
	else 
		echo "export LD_LIBRARY_PATH=\$LD_LIBRARY_PATH:\$1/lib64" >> share/creatools/creatools_TPLaux_config.sh
	fi

	cp $scriptDir/TPLaux-bashrc.sh share/creatools/TPLaux-bashrc.sh

# Fedora 31 
	if [ `getDistrib` == Fedora ] && [ `getDistribVersion` == 31 ] ; then 
    	mkdir lib64
	    cd lib64
		cp /usr/lib64/libwx*-3.0.so.0 .
		cp /usr/lib64/libboost_*.so.1.69.0 .
		cp /usr/lib64/libm.so.6 .
		cp /usr/lib64/libstdc++.so.6 .
		cp /usr/lib64/libSDL2-2.0.so.0 .
		cp /usr/lib64/libmspack.so.0 .
		cp /usr/lib64/libjpeg.so.62 .
		cp /usr/lib64/libicudata.so.63 .
		cp /usr/lib64/libicui18n.so.63 .
		cp /usr/lib64/libicuuc.so.63 .
	fi

# Fedora 28
	if [ `getDistrib` == Fedora ] && [ `getDistribVersion` == 28 ] ; then 
    	mkdir lib64
	    cd lib64
		cp /usr/lib64/libwx*-3.0.so.0 .
		cp /usr/lib64/libboost_*.so.1.66.0 .
		cp /usr/lib64/libjpeg.so.62 .
		cp /usr/lib64/libSDL2-2.0.so.0 .
		cp /usr/lib64/libmspack.so.0 .
		cp /usr/lib64/libmspack.so.0 .
		cp /usr/lib64/libicudata.so.60 .
		cp /usr/lib64/libicui18n.so.60 . 
		cp /usr/lib64/libicuuc.so.60 . 
		## For Fedora 32
		cp /usr/lib64/libGLU.so.1 . 
	fi


# MacOs
	if [ `getDistrib` == MacOS ]  ; then 
    	mkdir lib
	    cd lib
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_baseu-3.0.0.5.0.dylib      	    . 
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_osx_cocoau_core-3.0.0.5.0.dylib  	.  
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_osx_cocoau_adv-3.0.0.5.0.dylib   	.
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_osx_cocoau_html-3.0.0.5.0.dylib  	. 
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_osx_cocoau_aui-3.0.0.5.0.dylib   	. 
        cp /opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.0/lib/libwx_osx_cocoau_gl-3.0.0.5.0.dylib    	.  
        
        cp /opt/local/libexec/boost/1.76/lib/libboost_filesystem-mt.dylib  	    .
        cp /opt/local/libexec/boost/1.76/lib/libboost_system-mt.dylib 			.
        cp /opt/local/libexec/boost/1.76/lib/libboost_date_time-mt.dylib 		.
        cp /opt/local/libexec/boost/1.76/lib/libboost_thread-mt.dylib 			.
        cp /opt/local/libexec/boost/1.76/lib/libboost_regex-mt.dylib 			.
        cp /opt/local/libexec/boost/1.76/lib/libboost_program_options-mt.dylib 	.
        cp /opt/local/libexec/boost/1.76/lib/libboost_chrono-mt.dylib 			.
        cp /opt/local/libexec/boost/1.76/lib/libboost_atomic-mt.dylib 			.
        
        cp /opt/local/lib/libjpeg.8.dylib          .
        cp /opt/local/lib/libpng16.16.dylib        .
        cp /opt/local/lib/libtiff.5.dylib 	       .
        cp /opt/local/lib/libz.1.dylib 		       .
        cp /opt/local/lib/libzstd.1.dylib 	       .
        	
        cp /opt/local/lib/libicudata.67.dylib      .
        cp /opt/local/lib/libicui18n.67.dylib 	   .
        cp /opt/local/lib/libicuuc.67.dylib   	   .

		mkdir opt
        cp /opt/local/lib/libiconv.2.dylib 	       opt/.
        cp /opt/local/lib/liblzo2.2.dylib 	       .
        cp /opt/local/lib/liblz4.1.dylib 	       .
#        cp /opt/local/lib/libarchive.dylib 	       .
 #       cp /opt/local/lib/liblzma.5.dylib 	       .
  #      cp /opt/local/lib/libcharset.1.dylib 	   .
 #       cp /opt/local/lib/libbz2.1.0.dylib 	       .
   #     cp /opt/local/lib/libxml2.2.dylib 	       . 
        cp /opt/local/lib/libomp/libomp.dylib    . 
    fi


	cd ../..
	fileTGZaux=$creatoolsTPLaux-`getDistrib`-`getDistribVersion`.tgz
	rm -rf $fileTGZaux
	tar -cvzf $fileTGZaux $creatoolsTPLaux
	scp $fileTGZaux $distanceAdress/$fileTGZaux


## EED Borrame
##	fileTGZf28=CreaTools-Bin-Release-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion-Fedora-28.tgz
##	fileTGZauxf28=$creatoolsTPLaux-Fedora-28.tgz

	fileTGZf28=CreaTools-Bin-Release-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion-'$'VERFINALUSER.tgz
	fileTGZauxf28=$creatoolsTPLaux-'$'VERFINALUSER.tgz


	
#--------Script de Instalation :  creatools-Linux-Bin-x.x.x.sh   --------------------------------------------------------


	filename_BinVersion=creatools-Linux-Bin-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion.sh

	  echo "##" > $filename_BinVersion
	  echo "## Generated by CreaTools-GeneratedBinTGZ.sh" >> $filename_BinVersion
	  echo "##" >> $filename_BinVersion

	  cat creatools_install/share/creatools/Version.sh >> $filename_BinVersion
	  cat $scriptDir/LocalFunctions.sh >> $filename_BinVersion

     echo "ETC_BASHRC=\`getbashrc\`" >>  $filename_BinVersion


	  echo "if [ \"\$1\" == \"FinalUser\" ] ; then" >> $filename_BinVersion
	  echo "   if [ \`getDistrib\` == Fedora ] ; then ">> $filename_BinVersion 
	  echo "     VERFINALUSER=Fedora-28 ">> $filename_BinVersion 
	  echo "   fi ">> $filename_BinVersion 
	  echo "   if [ \`getDistrib\` == MacOS ] ; then ">> $filename_BinVersion 
	  echo "     VERFINALUSER=MacOS-10.11.6 ">> $filename_BinVersion 
	  echo "   fi ">> $filename_BinVersion 
	  echo "   \`getDownloadCommand\` https://www.creatis.insa-lyon.fr/software/public/creatools/creaTools/v\$creatoolsMajorVersion.x.x/$fileTGZf28" >> $filename_BinVersion 
	  echo "   tar -xvzf $fileTGZf28" >>  $filename_BinVersion
	  echo "   rm -f $fileTGZf28" >>  $filename_BinVersion
	  echo "   \`getDownloadCommand\` https://www.creatis.insa-lyon.fr/software/public/creatools/creaTools/v\$creatoolsMajorVersion.x.x/$fileTGZauxf28" >> $filename_BinVersion 
	  echo "   tar -xvzf $fileTGZauxf28" >>  $filename_BinVersion
	  echo "   rm -f $fileTGZauxf28" >>  $filename_BinVersion
	  
	  echo "  cd creatoolsTPLaux/lib" >>  $filename_BinVersion
	  echo "  ln -s libwx_baseu-3.0.0.5.0.dylib libwx_baseu-3.0.dylib" >>  $filename_BinVersion
	  echo "  ln -s libwx_osx_cocoau_adv-3.0.0.5.0.dylib libwx_osx_cocoau_adv-3.0.dylib" >>  $filename_BinVersion
	  echo "  ln -s libwx_osx_cocoau_aui-3.0.0.5.0.dylib libwx_osx_cocoau_aui-3.0.dylib" >>  $filename_BinVersion
	  echo "  ln -s libwx_osx_cocoau_core-3.0.0.5.0.dylib libwx_osx_cocoau_core-3.0.dylib" >>  $filename_BinVersion
	  echo "  ln -s libwx_osx_cocoau_gl-3.0.0.5.0.dylib libwx_osx_cocoau_gl-3.0.dylib" >>  $filename_BinVersion
	  echo "  ln -s libwx_osx_cocoau_html-3.0.0.5.0.dylib libwx_osx_cocoau_html-3.0.dylib" >>  $filename_BinVersion
#	  echo " ln -s libarchive.dylib libarchive.2.dylib" >>  $filename_BinVersion
	  echo "ACTUALDIRLINK=\$(pwd)" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_baseu-3.0.dylib" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_osx_cocoau_core-3.0.dylib" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_osx_cocoau_adv-3.0.dylib" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_osx_cocoau_html-3.0.dylib" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_osx_cocoau_aui-3.0.dylib" >>  $filename_BinVersion
	  echo "install_name_tool -change /opt/local/lib/libiconv.2.dylib \$ACTUALDIRLINK/opt/libiconv.2.dylib libwx_osx_cocoau_gl-3.0.dylib" >>  $filename_BinVersion
	  echo "  cd ../.." >>  $filename_BinVersion
	  
      echo "   installPrefixTPLaux=\$(pwd)/creatoolsTPLaux #You need this variable in the -barshrc script" >>  $filename_BinVersion
      echo "   source creatoolsTPLaux/share/creatools/TPLaux-bashrc.sh"  >>  $filename_BinVersion

	  echo "else" >> $filename_BinVersion
	  echo "   \`getDownloadCommand\` https://www.creatis.insa-lyon.fr/software/public/creatools/creaTools/v\$creatoolsMajorVersion.x.x/$fileTGZstring.tgz" >> $filename_BinVersion 
	  echo "   tar -xvzf $fileTGZstring.tgz" >>  $filename_BinVersion
	  echo "   rm -f $fileTGZstring.tgz" >>  $filename_BinVersion
      echo "   OperatingSystem=\`getDistrib\`  #You need this variable in the Base-Stuff script" >>  $filename_BinVersion
      echo "   cd thirdparty_install/share/creatools/"  >>  $filename_BinVersion
      echo "   source ThirdParty-install-Base-Stuff.sh \$OperatingSystem"  >>  $filename_BinVersion
      echo "   cd ../../.."  >>  $filename_BinVersion
	  echo "fi" >> $filename_BinVersion
	 

#EED     echo "source creatools_install/share/creatools/LocalFunctions.sh"  >>  $filename_BinVersion
     echo "installPrefix=\$(pwd)/creatools_install #You need this variable in the -barshrc script" >>  $filename_BinVersion
     echo "installPrefixThird=\$(pwd)/thirdparty_install #You need this variable in the -barshrc script" >>  $filename_BinVersion
     echo "source thirdparty_install/share/creatools/ThirdParty-bashrc.sh"  >>  $filename_BinVersion
     echo "source creatools_install/share/creatools/CreaTools-bashrc.sh"  >>  $filename_BinVersion
     echo "echo $fileTGZstring >> Creatools-Bin-Version.txt " >>  $filename_BinVersion

     echo "echo  " >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "echo 'Open a new terminal to run creatools.'" >>  $filename_BinVersion
     echo "echo '(Close this window and continue....)' " >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "echo  Install dir:" >>  $filename_BinVersion
     echo "pwd"    >>  $filename_BinVersion
     echo "echo  " >>  $filename_BinVersion
     echo "read -p 'Press [Enter] key to continue...'" >>  $filename_BinVersion
     scp $filename_BinVersion $distanceAdress/. 
     rm creatools_install
     rm thirdparty_install


#-----------------------------------------------------------------

	 cat $scriptDir/Install-Creatools-Bin.sh-downloadTool $scriptDir/Install-Creatools-Bin.sh > Install-Creatools-Bin-tmp.sh

     scp Install-Creatools-Bin-tmp.sh $distanceAdress/Install-Creatools-Bin-Release-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion.sh	  

	 ssh davila@tux.creatis.insa-lyon.fr "cd creatools/creaTools;rm Install-Creatools-Bin-Release.sh;  ln -s v4.x.x/Install-Creatools-Bin-Release-$creatoolsMajorVersion.$creatoolsMinorVersion.$creatoolsBuildVersion.sh  Install-Creatools-Bin-Release.sh"

	 ssh davila@tux.creatis.insa-lyon.fr "cd creatools/creaTools;rm creatools-Linux-Bin.sh;  ln -s v4.x.x/$filename_BinVersion  creatools-Linux-Bin.sh"



     echo ""
     echo ""
     echo ""
     echo "Creation OK:"
     echo $fileTGZ
     echo ""
     echo $PWD
	
  else
   echo
   echo "..ERROR.."
   echo "==================================================="
   echo "REMEMBER !"
   echo ""
   echo "You MUST run before:"
   echo "   > ./instalscript config"
   echo "   > ./instalscript 3rd"
   echo "   > ./instalscript creatools"
   echo "==================================================="
   echo
   echo 
   read a
   exit 0 
  fi  
  


