# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  

#!/bin/sh

currentdir=$2
VTKdir=$3
installPrefix=$4
dirInstall=$currentdir/tmpCreaTools_INSTALL/$1Bin
installPrefix=$4
buildType=$5

if [ buildType = "Debug" ]
then
debug = "ON"
else
debug = "OFF"
fi

echo dirInstall
echo $dirInstall

mkdir $dirInstall
cd $dirInstall
echo -H$currentdir/$1
echo -B$dirInstall/

## cmake -G"CodeBlocks - Unix Makefiles" -H$currentdir/$1 -B$dirInstall/
cmake -G"Unix Makefiles" -H$currentdir/$1 -B$dirInstall/
cmake -D BUILD_ALL:BOOL=ON -D USE_DEBUG_LIB:BOOL=$debug CMakeCache.txt

# the following line is the right one!
#cmake -D INCLUDE_CTEST:BOOL=ON -D CMAKE_INSTALL_PREFIX:PATH=$dirInstall -D crea_DIR:PATH=$currentdir/tmpCreaTools_INSTALL/creaBin CMakeCache.txt

# This one : only for misinstalled vtk:
# modify VTK_DIR:PATH=, acording to your own computer

cmake -D INCLUDE_CTEST:BOOL=ON -D BBTK_USE_WXWIDGETS:BOOL=ON -D VTK_DIR:PATH=$VTKdir -D crea_DIR:PATH=$currentdir/tmpCreaTools_INSTALL/creaBin -D BBTK_DIR:PATH=$currentdir/tmpCreaTools_INSTALL/bbtkBin -D CMAKE_INSTALL_PREFIX:PATH=$installPrefix CMakeCache.txt
cd ..
